June 9, 2026
— Immich Team
How to migrate from Immich v2 to Immich v3, and what breaking changes where introduced as part of Immich v3.
Everyone has been busy breaking Immich 😅
This purpose of this document is enumerate all the breaking changes were introduced as part of Immich v3 and provide migration steps when available.
This release includes a hefty list of breaking changes, most of which were previously deprecated. This post aims to document, explain, and guide users as they upgrade to v3.
The legacy timeline in the mobile app has been removed.
IMMICH_MACHINE_LEARNING_PING_TIMEOUTThe environment variable IMMICH_MACHINE_LEARNING_PING_TIMEOUT has been removed.
MACHINE_LEARNING_PRELOAD__CLIPThe environment variable MACHINE_LEARNING_PRELOAD__CLIP has been removed.
MACHINE_LEARNING_PRELOAD__FACIAL_RECOGNITIONThe environment variable MACHINE_LEARNING_PRELOAD__FACIAL_RECOGNITION has been removed.
A bump in numpy now requires x86 CPUs to be in the x86-64-v2 microarchitecture level or higher. This does not mean AVX is required; virtually every mainstream x86 CPU since 2010 meets the x86-64-v2 baseline.
Support for pgvecto.rs has been removed in v3. Using DB_VECTOR_EXTENSION=pgvecto.rs now throws an error.
OAuth http requests now no longer permit insecure requests by default. To keep using insecure requests, set oauth.allowInsecureRequests in admin > system config.
The oauth.issuerUrl system config property was previously only required to be a string. Now, it is required to parse as a valid URL.
Exported metric names have been updated: underscore (_) in metric names have been replaced with dot/periods (.).
AuditLogCleanup jobThe AuditLogCleanup job has been removed.
Previous to v3, the server used class-validator for request validation, but starting with v3, the server has migrated to Zod and now sends back a different error response object. Additionally, the correlationId response property has been migrated to the X-Correlation-ID response header.
{
"message": [
"[comment] Comment must not be provided when type is not COMMENT"
],
"error": "Bad Request",
"statusCode": 400,
"correlationId": "dtw6imvq"
}{
"message": "Validation failed",
"errors": [
{
"path": ["comment"],
"message": "Comment is required when type is COMMENT",
},
]
}Some error messages have been updated to avoid leaking resource existence or permission details. For more details see #28154.
The following endpoints no longer accept empty strings as a substitute for null.
Previous to v3 adding an asset to a shared link (without being logged in) required two API requests: one to upload the asset and another one to add it to the shared link. Now, assets are automatically added to the associated shared link when they are uploaded, removing the need to shared link access to the following APIs, which have been removed:
addAssetsToAlbum (PUT /albums/:id/assets)addAssetsToAlbums (PUT /albums/assets)addSharedLinkAssets (PUT /shared-links/:id/assets)Endpoints that require shared link authentication now no longer accept query.password. Instead, it should be send as body.password in the sharedLinkLogin (POST /shared-links) endpoint to login, receive a cookie, and use that with subsequent requests.
getAllAlbumsThe query parameters of the getAllAlbums (GET /albums) endpoint have been updated. shared has been renamed to isShared and a second parameter isOwner has been added. They now function as follows:
For more details refer to #28213.
createAlbum, updateAlbumInfo, getAllAlbums, etc. (AlbumResponseDto)Endpoints that return the AlbumResponseDto schema have the following changes:
ownerand ownerId properties have been removed (moved to albumUsers with a role of owner)assets property has been removed (use POST /api/search/assets instead)AssetMediaCreateDtodeviceId and deviceAssetId properties of AssetMediaCreateDto have been removed.AssetResponseDtodeviceId and deviceAssetId properties of AssetResponseDto have been removed.duration property now returns a number and can be null (represents milliseconds)unassignedFaces property has been removed (use GET /faces to retrieve asset face information)width and height properties have been changed from number to integerExifResponseDtoexifImageWidth, exifImageHeight, iso, and rating properties have been changed from number to integerPersonSearchDtopage and size properties have been changed from number to integer*SearchDtopage and size properties have been changed from number to integerrating property has been changed from number to integerSharedLinkEditDtochangeExpiryTime property of SharedLinkEditDto has been removed (instead send expiresAt with a null value)SharedLinkResponseThe token response property of SharedLinkResponse has been removed.
AudioCodec
libopus value has been removed (use opus instead)replaceAssestThe replaceAsset endpoint (PUT /assets/:id/original) has been removed. The API Key permission for this endpoint, asset.replace, has also been removed.
getRandomThe getRandom endpoint (GET /assets/random) has been removed.
getDeltaSyncThe getDeltaSync endpoint (POST /sync/delta-sync) has been removed.
getFullSyncForUserThe getFullSyncForUser endpoint POST /sync/full-sync has been removed.
getThemeThe getTheme endpoint (GET /server/theme) has been removed.
checkExistingAssetsThe checkExistingAssets endpoint (POST /assets/exists) has been removed.
getAllUserAssetsByDeviceIdThe getAllUserAssetsByDeviceId endpoint (GET /assets/device/:deviceId) has been removed.
Cheers,
The Immich Team